var pts = require("../lib/pts.js");
var assert = require("assert");

function str(a) { return JSON.stringify(a); }

function ident(nm) { return ["ident", nm]; }
function abs(nm,ty,body) { return ["Expr_Abs", nm, ty, body]; }
var identX = ident("x");
var exprX = ["Expr", ["Expr_Var", ["ident", "x"]]];
var exprY = ["Expr", ["Expr_Var", ["ident", "y"]]];

/*
describe('parse', function() {
  describe('Expr', function() {
    it("parse idents", function() {
      assert.equal(
        str(pts.parseAst("x","Expr")), 
        str(exprX));
    });
    it("parse abs", function() {
      assert.equal(
        str(pts.parseAst("\\x:y.x","Expr")), 
        str(abs(ident("x"), exprY, exprX)));
    });
  });
});
*/

describe('sort', function() {
  function expect(str,sort) {
    assert.equal(
      pts.parse(str,"Expr", pts.sort()),
      sort);
  }

  describe('kinds', function() {
    it("*", function() {             expect('*', '#')            });
    it('* -> * : #', function() {    expect('* -> *', '#')       });
    it('# -> * : #', function() {    expect('# -> *', '#')       });
    it('\\x:*.x : #', function() {   expect('\\x:*.x', '#')      });
  });

  describe('types', function() {

  });
});


describe('haskell', function() {
  function expect(str,hs) {
    it(str, function() { assert.equal(pts.parse(str,"Expr", pts.haskell), hs) })
  }

  expect('*', 'Star');
  expect('#', 'Box');
  expect('* -> *', '(Pi "" Star Star)');
  expect('Pi x:*. x', '(Pi "x" Star (Var "x"))');
  expect('let x:#=* in x', '(App (Lam "x" Box (Var "x")) Star)');
});

