module Language.SystemU.Builtins where
import Language.SystemU.Syntax
import qualified Language.SystemU.Core as C

-- variables used for building quotations
vVar       = var "Var"
vProdStar  = var "ProdStar"
vProdBox   = var "ProdBox"
vProdDelta = var "ProdDelta"
vExp       = var "Exp"
vPExp      = var "PExp"

vMkRep     = var "mkRep"
vMkAbsStar = var "mkAbsStar"
vMkAppStar = var "mkAppStar"
vMkAbsBox  = var "mkAbsBox"
vMkAppBox  = var "mkAppBox"
vMkAbsDelta  = var "mkAbsDelta"
vMkAppDelta  = var "mkAppDelta"

vU         = var "U"

u         = norm $ fromCore C.u

-- type representation constructors
_Var       = norm $ fromCore C.var
_ProdStar  = norm $ fromCore C.prodStar
_ProdBox   = norm $ fromCore C.prodBox
_ProdDelta = norm $ fromCore C.prodDelta

-- term representation constructors
mkRep       = norm $ fromCore C.mkRep
mkAbsStar   = norm $ fromCore C.mkAbsStar
mkAppStar   = norm $ fromCore C.mkAppStar
mkAbsBox    = norm $ fromCore C.mkAbsBox
mkAppBox    = norm $ fromCore C.mkAppBox
mkAbsDelta  = norm $ fromCore C.mkAbsDelta
mkAppDelta  = norm $ fromCore C.mkAppDelta

_DistExpStar      = norm $ fromCore C._DistExpStar
_DistExpBox       = norm $ fromCore C._DistExpBox
_DistExpDelta     = norm $ fromCore C._DistExpDelta

_FactorExpStar    = norm $ fromCore C._FactorExpStar
_FactorExpBox     = norm $ fromCore C._FactorExpBox
_FactorExpDelta   = norm $ fromCore C._FactorExpDelta

_CoerceExpStar    = norm $ fromCore C._CoerceExpStar
_CoerceExpBox     = norm $ fromCore C._CoerceExpBox
_CoerceExpDelta   = norm $ fromCore C._CoerceExpDelta

coerceExpStar    = norm $ fromCore C.coerceExpStar
coerceExpBox     = norm $ fromCore C.coerceExpBox
coerceExpDelta   = norm $ fromCore C.coerceExpDelta

_ReifyVar         = norm $ fromCore C._ReifyVar
_ReifyProdStar    = norm $ fromCore C._ReifyProdStar
_ReifyProdBox     = norm $ fromCore C._ReifyProdBox
_ReifyProdDelta   = norm $ fromCore C._ReifyProdDelta

reifyVar         = norm $ fromCore C.reifyVar
reifyProdStar    = norm $ fromCore C.reifyProdStar
reifyProdBox     = norm $ fromCore C.reifyProdBox
reifyProdDelta   = norm $ fromCore C.reifyProdDelta


_ReflectProdStar  = norm $ fromCore C._ReflectProdStar
_ReflectProdBox   = norm $ fromCore C._ReflectProdBox
_ReflectProdDelta = norm $ fromCore C._ReflectProdDelta

reflectProdStar  = norm $ fromCore C.reflectProdStar
reflectProdBox   = norm $ fromCore C.reflectProdBox
reflectProdDelta = norm $ fromCore C.reflectProdDelta

_Exp        = norm $ fromCore C.exp
_PExp       = norm $ fromCore C.pExp


replib = zip nms tms
  where nms = words . unwords $ [
                "U"
              , "Var ProdStar ProdBox ProdDelta "
              , "PExp Exp "  
              , "mkRep mkAbsStar mkAppStar mkAbsBox mkAppBox mkAbsDelta mkAppDelta"
              ]  
        tms = [ u, _Var, _ProdStar, _ProdBox, _ProdDelta
              , _PExp, _Exp
              , mkRep, mkAbsStar, mkAppStar, mkAbsBox, mkAppBox, mkAbsDelta, mkAppDelta]

